#include <stdio.h>
#include <stdlib.h>
#include <string.h>  

#define MAX 20000

typedef struct sta {
    int item[MAX];
    int top;
} sta;

void initsta(sta *s) {
    s->top = -1;
}


int isFull(sta *s) {
    return s->top == MAX - 1;  
}


int empty(sta *s) {
    return s->top == -1;  
}


int pop(sta *s) {
    if (empty(s)) {
        return -1;  
    } else {
        return s->item[s->top--];  
    }
}


void push(sta *s, int value) {
    if (!isFull(s)) {
        s->item[++s->top] = value;  
    }
}


int query(sta *s) {
    if (!empty(s)) {
        return s->item[s->top];  
    } else {
        return -1;  
    }
}

int main() {
    sta sta; 
    initsta(&sta); 

    int n;  
    scanf("%d", &n);

    for (int i = 0; i < n; i++) {
        char m[10]; 
        scanf("%s", m);

        if (strcmp(m, "empty") == 0) {
            if (empty(&sta)) {
                printf("YES\n");
            } else {
                printf("NO\n");
            }
        } else if (strcmp(m, "push") == 0) {
            int k;
            scanf("%d", &k);
            push(&sta, k);  
        } else if (strcmp(m, "pop") == 0) {
            int poppedValue = pop(&sta);  
           
        } else if (strcmp(m, "query") == 0) {
            int topValue = query(&sta); 
            if (topValue != -1) {
                printf("%d\n", topValue);
            }
        }
    }

    return 0;
}